Morpho V1 Vault Markets
Returns the individual Morpho Blue markets a specific Morpho V1 vault allocates liquidity to, with per-market supply and borrow APYs, utilization, LLTV, and USD allocation. It breaks down how a vault's deposits are spread across the underlying lending markets.
GET
https://api.cambrian.org/evm/lending/morpho/v1/vault/markets
Parameters
chain_id (integer)
EVM chain ID.
vault_address* (string)
Morpho V1 vault address.
order_asc (array)
List of column names to order by in ascending order divided by comma. Leave empty items to combine with descending order
order_desc (array)
List of column names to order by in descending order divided by comma. Leave empty items to combine with ascending order
Responses
Code
Description
200
Successful response
Media type: application/vnd.cambrian.table.v1.0.0+json
[
{
"columns": [
{
"name": "chainId",
"type": "UInt16"
},
{
"name": "protocolId",
"type": "String"
},
{
"name": "marketId",
"type": "FixedString(66)"
},
{
"name": "loanAddress",
"type": "String"
},
{
"name": "loanSymbol",
"type": "String"
},
{
"name": "collateralAddress",
"type": "String"
},
{
"name": "collateralSymbol",
"type": "String"
},
{
"name": "supplyApy",
"type": "Float64"
},
{
"name": "borrowApy",
"type": "Float64"
},
{
"name": "utilizationRate",
"type": "Float64"
},
{
"name": "lltv",
"type": "Float64"
},
{
"name": "allocationUsd",
"type": "Float64"
},
{
"name": "allocationShare",
"type": "Float64"
},
{
"name": "supplyCapUsd",
"type": "Float64"
},
{
"name": "updatedAt",
"type": "DateTime('UTC')"
}
],
"data": [
[
8453,
"morpho-blue",
"0x1c21c59df9db44bf6f645d854ee710a8ca17b479451447e9f56758aee10a2fad",
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
"0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
"cbETH",
0.04708152117902422,
0.052205653046534906,
0.9018471838108575,
0.86,
17728.133393835436,
0.00015261736418925248,
50000000,
"2026-10-23T21:55:51+00:00"
],
[
8453,
"morpho-blue",
"0x9103c3b4e834476c9a62ea009ba2c884ee42e94e6e314a26f04d312434191836",
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
"0xcbb7c0000ab88b473b1f5afd9ef808440eed33bf",
"cbBTC",
0.046943838458642445,
0.05209529524237455,
0.9011147405967307,
0.86,
112546928.65670003,
0.968890250180213,
1000000000,
"2026-10-23T22:01:49+00:00"
],
[
8453,
"morpho-blue",
"0x13c42741a359ac4a8aa8287d2be109dcf28344484f91185f9a79bd5a805a55ae",
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
"0xc1cba3fcea344f92d9239c08c0568f6f2f0ee452",
"wstETH",
0.04681824128010397,
0.05196273135205787,
0.9009965423661249,
0.86,
14247.76466863813,
0.00012265568184817633,
50000000,
"2026-10-23T21:39:33+00:00"
],
[
8453,
"morpho-blue",
"0x0ca10126f6c94cbd9cf0a48cc9516ae5e3dec5aa68303e6d988ee37c5149bf0d",
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
"0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
"cbETH",
0.04679531128908139,
0.05195381406455568,
0.900709834910974,
0.77,
2967340.956776855,
0.02554514597862699,
200000000,
"2026-10-23T22:00:43+00:00"
],
[
8453,
"morpho-blue",
"0x8793cf302b8ffd655ab97bd1c695dbd967807e8367a65cb2f4edaf1380ba1bda",
"0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
"USDC",
"0x4200000000000000000000000000000000000006",
"WETH",
0.04636164520582025,
0.05147807502189905,
0.9006095349544005,
0.86,
614452.280224284,
0.005289676320943903,
200000000,
"2026-10-23T22:01:19+00:00"
]
],
"rows": 5
}
]
400
Bad Request: Invalid request parameters or malformed request.
401
Unauthorized: Missing or invalid API key. Include X-API-Key header with your request.
403
Forbidden: Invalid API key or insufficient permissions to access this resource.
404
Not Found: Endpoint or resource does not exist.
408
Request Timeout: Request took too long to process. Try again.
500
Internal Server Error: An unexpected error occurred while processing your request.
503
Service Unavailable: The server is temporarily unable to handle the request. Please try again later.
Examples
1. Fetch markets for a Morpho V1 vault
Retrieve all markets that a specific Morpho V1 vault (on Base, chain_id 8453) allocates liquidity to.
curl
curl -X GET "https://api.cambrian.org/evm/lending/morpho/v1/vault/markets?vault_address=0xbeef010f9cb27031ad51e3333f9af9c6b1228183" \
-H "X-API-Key: YOUR_API_KEY" \
-H "Content-Type: application/json"
Response:
JSON
1[
2 {
3 "columns": [
4 {
5 "name": "chainId",
6 "type": "UInt16"
7 },
8 {
9 "name": "protocolId",
10 "type": "String"
11 },
12 {
13 "name": "marketId",
14 "type": "FixedString(66)"
15 },
16 {
17 "name": "loanAddress",
18 "type": "String"
19 },
20 {
21 "name": "loanSymbol",
22 "type": "String"
23 },
24 {
25 "name": "collateralAddress",
26 "type": "String"
27 },
28 {
29 "name": "collateralSymbol",
30 "type": "String"
31 },
32 {
33 "name": "supplyApy",
34 "type": "Float64"
35 },
36 {
37 "name": "borrowApy",
38 "type": "Float64"
39 },
40 {
41 "name": "utilizationRate",
42 "type": "Float64"
43 },
44 {
45 "name": "lltv",
46 "type": "Float64"
47 },
48 {
49 "name": "allocationUsd",
50 "type": "Float64"
51 },
52 {
53 "name": "allocationShare",
54 "type": "Float64"
55 },
56 {
57 "name": "supplyCapUsd",
58 "type": "Float64"
59 },
60 {
61 "name": "updatedAt",
62 "type": "DateTime('UTC')"
63 }
64 ],
65 "data": [
66 [
67 8453,
68 "morpho-blue",
69 "0x1c21c59df9db44bf6f645d854ee710a8ca17b479451447e9f56758aee10a2fad",
70 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
71 "USDC",
72 "0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
73 "cbETH",
74 0.04708152117902422,
75 0.052205653046534906,
76 0.9018471838108575,
77 0.86,
78 17728.133393835436,
79 0.00015261736418925248,
80 50000000,
81 "2026-10-23T21:55:51+00:00"
82 ],
83 [
84 8453,
85 "morpho-blue",
86 "0x9103c3b4e834476c9a62ea009ba2c884ee42e94e6e314a26f04d312434191836",
87 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
88 "USDC",
89 "0xcbb7c0000ab88b473b1f5afd9ef808440eed33bf",
90 "cbBTC",
91 0.046943838458642445,
92 0.05209529524237455,
93 0.9011147405967307,
94 0.86,
95 112546928.65670003,
96 0.968890250180213,
97 1000000000,
98 "2026-10-23T22:01:49+00:00"
99 ],
100 [
101 8453,
102 "morpho-blue",
103 "0x13c42741a359ac4a8aa8287d2be109dcf28344484f91185f9a79bd5a805a55ae",
104 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
105 "USDC",
106 "0xc1cba3fcea344f92d9239c08c0568f6f2f0ee452",
107 "wstETH",
108 0.04681824128010397,
109 0.05196273135205787,
110 0.9009965423661249,
111 0.86,
112 14247.76466863813,
113 0.00012265568184817633,
114 50000000,
115 "2026-10-23T21:39:33+00:00"
116 ],
117 [
118 8453,
119 "morpho-blue",
120 "0x0ca10126f6c94cbd9cf0a48cc9516ae5e3dec5aa68303e6d988ee37c5149bf0d",
121 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
122 "USDC",
123 "0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
124 "cbETH",
125 0.04679531128908139,
126 0.05195381406455568,
127 0.900709834910974,
128 0.77,
129 2967340.956776855,
130 0.02554514597862699,
131 200000000,
132 "2026-10-23T22:00:43+00:00"
133 ],
134 [
135 8453,
136 "morpho-blue",
137 "0x8793cf302b8ffd655ab97bd1c695dbd967807e8367a65cb2f4edaf1380ba1bda",
138 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
139 "USDC",
140 "0x4200000000000000000000000000000000000006",
141 "WETH",
142 0.04636164520582025,
143 0.05147807502189905,
144 0.9006095349544005,
145 0.86,
146 614452.280224284,
147 0.005289676320943903,
148 200000000,
149 "2026-10-23T22:01:19+00:00"
150 ]
151 ],
152 "rows": 5
153 }
154]
2 {
3 "columns": [
4 {
5 "name": "chainId",
6 "type": "UInt16"
7 },
8 {
9 "name": "protocolId",
10 "type": "String"
11 },
12 {
13 "name": "marketId",
14 "type": "FixedString(66)"
15 },
16 {
17 "name": "loanAddress",
18 "type": "String"
19 },
20 {
21 "name": "loanSymbol",
22 "type": "String"
23 },
24 {
25 "name": "collateralAddress",
26 "type": "String"
27 },
28 {
29 "name": "collateralSymbol",
30 "type": "String"
31 },
32 {
33 "name": "supplyApy",
34 "type": "Float64"
35 },
36 {
37 "name": "borrowApy",
38 "type": "Float64"
39 },
40 {
41 "name": "utilizationRate",
42 "type": "Float64"
43 },
44 {
45 "name": "lltv",
46 "type": "Float64"
47 },
48 {
49 "name": "allocationUsd",
50 "type": "Float64"
51 },
52 {
53 "name": "allocationShare",
54 "type": "Float64"
55 },
56 {
57 "name": "supplyCapUsd",
58 "type": "Float64"
59 },
60 {
61 "name": "updatedAt",
62 "type": "DateTime('UTC')"
63 }
64 ],
65 "data": [
66 [
67 8453,
68 "morpho-blue",
69 "0x1c21c59df9db44bf6f645d854ee710a8ca17b479451447e9f56758aee10a2fad",
70 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
71 "USDC",
72 "0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
73 "cbETH",
74 0.04708152117902422,
75 0.052205653046534906,
76 0.9018471838108575,
77 0.86,
78 17728.133393835436,
79 0.00015261736418925248,
80 50000000,
81 "2026-10-23T21:55:51+00:00"
82 ],
83 [
84 8453,
85 "morpho-blue",
86 "0x9103c3b4e834476c9a62ea009ba2c884ee42e94e6e314a26f04d312434191836",
87 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
88 "USDC",
89 "0xcbb7c0000ab88b473b1f5afd9ef808440eed33bf",
90 "cbBTC",
91 0.046943838458642445,
92 0.05209529524237455,
93 0.9011147405967307,
94 0.86,
95 112546928.65670003,
96 0.968890250180213,
97 1000000000,
98 "2026-10-23T22:01:49+00:00"
99 ],
100 [
101 8453,
102 "morpho-blue",
103 "0x13c42741a359ac4a8aa8287d2be109dcf28344484f91185f9a79bd5a805a55ae",
104 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
105 "USDC",
106 "0xc1cba3fcea344f92d9239c08c0568f6f2f0ee452",
107 "wstETH",
108 0.04681824128010397,
109 0.05196273135205787,
110 0.9009965423661249,
111 0.86,
112 14247.76466863813,
113 0.00012265568184817633,
114 50000000,
115 "2026-10-23T21:39:33+00:00"
116 ],
117 [
118 8453,
119 "morpho-blue",
120 "0x0ca10126f6c94cbd9cf0a48cc9516ae5e3dec5aa68303e6d988ee37c5149bf0d",
121 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
122 "USDC",
123 "0x2ae3f1ec7f1f5012cfeab0185bfc7aa3cf0dec22",
124 "cbETH",
125 0.04679531128908139,
126 0.05195381406455568,
127 0.900709834910974,
128 0.77,
129 2967340.956776855,
130 0.02554514597862699,
131 200000000,
132 "2026-10-23T22:00:43+00:00"
133 ],
134 [
135 8453,
136 "morpho-blue",
137 "0x8793cf302b8ffd655ab97bd1c695dbd967807e8367a65cb2f4edaf1380ba1bda",
138 "0x833589fcd6edb6e08f4c7c32d4f71b54bda02913",
139 "USDC",
140 "0x4200000000000000000000000000000000000006",
141 "WETH",
142 0.04636164520582025,
143 0.05147807502189905,
144 0.9006095349544005,
145 0.86,
146 614452.280224284,
147 0.005289676320943903,
148 200000000,
149 "2026-10-23T22:01:19+00:00"
150 ]
151 ],
152 "rows": 5
153 }
154]
x402 Payment Option
This endpoint supports pay-per-use access via the x402 payment protocol (v2): pay $0.05 USDC per request using blockchain micropayments. No API key required.
Quickstart (Typescript)
bash
npm install @x402/fetch @x402/evm viem
TypeScript
1import { x402Client } from "@x402/core/client";
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/evm/lending/morpho/v1/vault/markets"
11);
12const data = await response.json();
2import { ExactEvmScheme } from "@x402/evm/exact/client";
3import { wrapFetchWithPayment } from "@x402/fetch";
4import { privateKeyToAccount } from "viem/accounts";
5const signer = privateKeyToAccount(process.env.EVM_PRIVATE_KEY as `0x${string}`);
6const client = new x402Client();
7client.register("eip155:*", new ExactEvmScheme(signer));
8const fetchWithPayment = wrapFetchWithPayment(fetch, client);
9const response = await fetchWithPayment(
10 "https://x402.cambrian.org/evm/lending/morpho/v1/vault/markets"
11);
12const data = await response.json();
Quickstart (Python)
bash
pip install "x402[httpx]"
Python
1import asyncio, os
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/evm/lending/morpho/v1/vault/markets")
13 print(response.json())
14asyncio.run(main())
2from eth_account import Account
3from x402 import x402Client
4from x402.http.clients import x402HttpxClient
5from x402.mechanisms.evm import EthAccountSigner
6from x402.mechanisms.evm.exact.register import register_exact_evm_client
7async def main():
8 client = x402Client()
9 account = Account.from_key(os.getenv("EVM_PRIVATE_KEY"))
10 register_exact_evm_client(client, EthAccountSigner(account))
11 async with x402HttpxClient(client) as http:
12 response = await http.get("https://x402.cambrian.org/evm/lending/morpho/v1/vault/markets")
13 print(response.json())
14asyncio.run(main())
Payment Flow
- Send a normal request to the endpoint (no API key needed)
- Server returns 402 Payment Required with payment details
- The x402 SDK automatically signs a payment authorization with your wallet
- The SDK resubmits the request with the signed payment
- Server verifies payment and returns the API response
The x402 SDK handles steps 2 through 5 automatically.
Network: Base (chain ID 8453) | Currency: USDC | Price: $0.05 per request